        #include <cmrc/cmrc.hpp>
#include <map>
#include <utility>

namespace cmrc {
namespace app {

namespace res_chars {
// These are the files which are available in this resource library
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/bg.jpg
extern const char* const f_9e04_web_bg_jpg_begin;
extern const char* const f_9e04_web_bg_jpg_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/exConfirm.js
extern const char* const f_ed80_web_exConfirm_js_begin;
extern const char* const f_ed80_web_exConfirm_js_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/fail.png
extern const char* const f_0dae_web_fail_png_begin;
extern const char* const f_0dae_web_fail_png_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/index.html
extern const char* const f_d23f_web_index_html_begin;
extern const char* const f_d23f_web_index_html_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/main.js
extern const char* const f_e82c_web_main_js_begin;
extern const char* const f_e82c_web_main_js_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/pass.png
extern const char* const f_2287_web_pass_png_begin;
extern const char* const f_2287_web_pass_png_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/scanning.gif
extern const char* const f_86dd_web_scanning_gif_begin;
extern const char* const f_86dd_web_scanning_gif_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/style.css
extern const char* const f_cfd4_web_style_css_begin;
extern const char* const f_cfd4_web_style_css_end;
// Pointers to /builds/holo/holo/holo/steamos-repair-tool-git/src/steamos-repair-tool/cef_app/web/system_proxy.js
extern const char* const f_06e1_web_system_proxy_js_begin;
extern const char* const f_06e1_web_system_proxy_js_end;
}

namespace {

const cmrc::detail::index_type&
get_root_index() {
    static cmrc::detail::directory root_directory_;
    static cmrc::detail::file_or_directory root_directory_fod{root_directory_};
    static cmrc::detail::index_type root_index;
    root_index.emplace("", &root_directory_fod);
    struct dir_inl {
        class cmrc::detail::directory& directory;
    };
    dir_inl root_directory_dir{root_directory_};
    (void)root_directory_dir;
    static auto f_2567_web_dir = root_directory_dir.directory.add_subdir("web");
    root_index.emplace("web", &f_2567_web_dir.index_entry);
    root_index.emplace(
        "web/bg.jpg",
        f_2567_web_dir.directory.add_file(
            "bg.jpg",
            res_chars::f_9e04_web_bg_jpg_begin,
            res_chars::f_9e04_web_bg_jpg_end
        )
    );
    root_index.emplace(
        "web/exConfirm.js",
        f_2567_web_dir.directory.add_file(
            "exConfirm.js",
            res_chars::f_ed80_web_exConfirm_js_begin,
            res_chars::f_ed80_web_exConfirm_js_end
        )
    );
    root_index.emplace(
        "web/fail.png",
        f_2567_web_dir.directory.add_file(
            "fail.png",
            res_chars::f_0dae_web_fail_png_begin,
            res_chars::f_0dae_web_fail_png_end
        )
    );
    root_index.emplace(
        "web/index.html",
        f_2567_web_dir.directory.add_file(
            "index.html",
            res_chars::f_d23f_web_index_html_begin,
            res_chars::f_d23f_web_index_html_end
        )
    );
    root_index.emplace(
        "web/main.js",
        f_2567_web_dir.directory.add_file(
            "main.js",
            res_chars::f_e82c_web_main_js_begin,
            res_chars::f_e82c_web_main_js_end
        )
    );
    root_index.emplace(
        "web/pass.png",
        f_2567_web_dir.directory.add_file(
            "pass.png",
            res_chars::f_2287_web_pass_png_begin,
            res_chars::f_2287_web_pass_png_end
        )
    );
    root_index.emplace(
        "web/scanning.gif",
        f_2567_web_dir.directory.add_file(
            "scanning.gif",
            res_chars::f_86dd_web_scanning_gif_begin,
            res_chars::f_86dd_web_scanning_gif_end
        )
    );
    root_index.emplace(
        "web/style.css",
        f_2567_web_dir.directory.add_file(
            "style.css",
            res_chars::f_cfd4_web_style_css_begin,
            res_chars::f_cfd4_web_style_css_end
        )
    );
    root_index.emplace(
        "web/system_proxy.js",
        f_2567_web_dir.directory.add_file(
            "system_proxy.js",
            res_chars::f_06e1_web_system_proxy_js_begin,
            res_chars::f_06e1_web_system_proxy_js_end
        )
    );
    return root_index;
}

}

cmrc::embedded_filesystem get_filesystem() {
    static auto& index = get_root_index();
    return cmrc::embedded_filesystem{index};
}

} // app
} // cmrc
    