// SPDX-License-Identifier: GPL-2.0+

// Copyright © 2022 Collabora Ltd
// Copyright © 2022 Valve Corporation

#ifndef APP_H_
#define APP_H_

#include "include/cef_app.h"
#include "custom_scheme.h"

class App : public CefApp, public CefBrowserProcessHandler {
 public:
  App();

  void OnBeforeCommandLineProcessing(
      const CefString& process_type,
      CefRefPtr<CefCommandLine> command_line) override {
    command_line->AppendSwitch("--disable-web-security");
    //command_line->AppendSwitch("--single-process");
    command_line->AppendSwitch("--disable-sync");
    command_line->AppendSwitch("--ignore-gpu-blacklist");
    command_line->AppendSwitch("--start-fullscreen"); // FIXME: Not working
  }

  CefRefPtr<CefBrowserProcessHandler> GetBrowserProcessHandler() override {
    return this;
  }

  void OnRegisterCustomSchemes(CefRawPtr<CefSchemeRegistrar> registrar) override {
    registrar->AddCustomScheme(kScheme, kSchemeRegistrationOptions);
  }

  void OnContextInitialized() override;
  CefRefPtr<CefClient> GetDefaultClient() override;

 private:
  IMPLEMENT_REFCOUNTING(App);
};

#endif
